import json
import os
import sys
import hashlib
import argparse
import subprocess
import re

sdkCfgPath = 'codegen/in/'
swaggerPath = 'codegen/in/swagger/'
sdkPath = 'codegen/out/'

class Swag:
    def __init__(self):
        self.path = ''
        self.fileName = ''
        self.sha256Sum = ''
        self.shortName = ''
        self.allSwaggerFiles = {} # contains a Swag class object for all swagger files in swagger Path directory

    # setShortName shrinks the long F5XC swagger name to something easier to work with
    def setShortName(self):
        pattern = re.compile(r'.*schema\.([a-z_\.0-9]+)\.ves-swagger\.json')
        match = pattern.findall(self.fileName)
        if match is None or len(match) < 1:
            print("Error with regex for swagger file: {}, default to full file name".format(self.fileName))
            myMatch = self.fileName
        else:
            myMatch = match[0]

        self.shortName = myMatch.replace('.', '_')

    # setSHA256Sum sets the sha256 checksum of the swagger file, this is used to track swagger file version
    def setSHA256Sum(self):
        with open(self.path,"rb") as f:
            data = f.read() 
            f.close()
            self.sha256Sum = hashlib.sha256(data).hexdigest()

    # generateSDK calls the swagger.io docker generate for the given swagger file
    def generateSDK(self, swaggerName):
        if swaggerName not in self.allSwaggerFiles.keys():
            print("ERROR provided swagger is not found on the system, ", swaggerName)
            sys.exit(2)

        cfg = {}
        cfg['packageName'] = 'f5xc_{}_client'.format(swaggerName)
        cfg['projectName'] = cfg['packageName']
        cfg['packageVersion'] = self.sha256Sum

        print(cfg)

        try: 
            myCfgPath = os.path.join(sdkCfgPath, '{}.json'.format(swaggerName))
            f = open(myCfgPath, 'w')
            f.write(json.dumps(cfg))
            f.close()
        except Exception as e:
            print("ERROR unable to write SDK config for swagger: {} with error: {}".format(swaggerName, e))
            sys.exit(2)

        dockerPath = self.allSwaggerFiles[swaggerName].path.replace('codegen', '/local')
        cfgParts = myCfgPath.split('/')
        if len(cfgParts) < 2:
            print("ERROR with swagger generate config file, ", cfgParts)
            sys.exit(2)
        dockerCfgPath = cfgParts[-1]

        folderMap = '{}/codegen:/local'.format(os.getcwd())
        generateOut ='/local/out/{}'.format(swaggerName)
        generateIn = '/local/in/{}'.format(dockerCfgPath)
       
        cmd = ['docker', 'run', '--rm', '-v', folderMap, 'swaggerapi/swagger-codegen-cli', 'generate', '-i', dockerPath, '-o', generateOut, '-c', generateIn, '-l', 'python']
        print("DEBUG: Docker Command: ", ' '.join(cmd))
        try:
            subprocess.run(cmd, shell=False)
            f = open(os.path.join(sdkPath, swaggerName, '.version'), 'w') 
            f.write(self.allSwaggerFiles[swaggerName].sha256Sum)
            f.close()
        except Exception as e:
            print("ERROR while writing SDK version file for swagger: {} with error: {}".format(swaggerName, e))
            sys.exit(2)
            
    # getSwaggerFiles searches the swaggerPath directory for any .json file and adds them to the allSwaggerFiles dictionary 
    # The dictionary contains the Swag class object for each file found. 
    def getSwaggerFiles(self):
        try:
            for root, dirs, files in os.walk(swaggerPath):
                for file in files:
                    if file.endswith('.json'):
                        fileSwag = Swag()
                        fileSwag.path = os.path.join(root, file)
                        fileSwag.fileName = file
                        fileSwag.setSHA256Sum()
                        fileSwag.setShortName()
                        self.allSwaggerFiles[fileSwag.shortName]=fileSwag

        except Exception as e:
            print("ERROR with getting swagger files: ", e)
            sys.exit(2)

# listAllSDK lists all found directories in the sdkPATH. This represents all the SDKs generated by this tool on the system
    def listAllSDK(self):
        mySDK= []
        try:
            for file in os.listdir(sdkPath):
                d = os.path.join(sdkPath, file)
                if os.path.isdir(d):
                    mySDK.append(file)

        except Exception as e:
            print("ERROR with getting SDK files: {}. If this is the first time running you will need to first generate the Client SDKs".format(e))
            sys.exit(2)
        {print(x) for x in mySDK}


parser = argparse.ArgumentParser(description="F5XC SDK Generate Helper")
parser.add_argument('--listAllSwagger', action='store_true', help='list all available swagger files to generate, stored under "codegen/in/swagger/"')
parser.add_argument('--listAllSDK', action='store_true', help='list all created SDKs, stored under "codegen/out/"')
parser.add_argument('--generate', help='generate the provided swagger name')
args = parser.parse_args()

mySwag = Swag()

if args.listAllSDK:
    mySwag.listAllSDK()
    sys.exit(0)

mySwag.getSwaggerFiles()

if args.listAllSwagger:
    {print("swagger: {} file_path: {}".format(k, v.path)) for k, v in mySwag.allSwaggerFiles.items()}
    sys.exit(0)

if args.generate is not None:
    mySwag.generateSDK(args.generate)